/*
 * Simple Framework - QtWidgets Extension v0.5
 *
 * Copyleft 2012, Valentin Schmidt
 * Date: 2012-04-28
 *
 * Requirements: QtWidgets Xtra
 *
 * Just a stub, work in progress...
 */

// "xtra QtWidgets
//
// new object me
// 
// -- GENERAL
// setDropCallback object me, symbol callback, *callbackTarget
// setIdleSleep object me, integer milliseconds
// setWhatsThisMode object me, integer enable
// loadResourceFile object me, string resFilename
// loadResourceData object me, any resData
// 
// -- OBJECTS
// newObject object me, symbol objectClass, *parentWidgetID
// setObjectCallback object me, integer objectID, symbol signal, symbol callback, *callbackTarget
// callObject object me, integer objectID, symbol action, *arguments
// 
// -- WIDGETS/WINDOWS/DIALOGS
// createWidgetRegion object me, *rect, hwnd
// newWidget object me, any widgetClassOrUIFileOrData, *parentID, options
// newWindow object me, any widgetClassOrUIFileOrData, *options
// newDialog object me, symbol widgetClass, *parentID, options
// setWidgetCallback object me, integer widgetID, symbol signal, symbol callback, *callbackTarget
// setEventCallback object me, integer widgetID, integer eventType, symbol callback, *callbackTarget
// callWidget object me, integer widgetID, symbol action, *arguments


this.scriptfile = "framework_qt.js"; // useful for debugging
	
$.qtInit = function(ms){
	this.gQt = new xtra("QtWidgets");
	if (ms) this.qtSetIdleSleep(ms);
}

$.qtDestroy = function(){
	this.gQt = 0;
	_system.gc();
}

var __qtDropCallback__ = function(pl){
	if (typeof $.DropCallback=="function"){
		//$.DropCallback.apply($.DropCallback, [pl]);
		
		var o = {};
		var cnt = pl.count;
		for (var i=1;i<=cnt;i++){
			var ba = pl.getAt(i);
			var v = ba.readRawString(ba.length);
			o[pl.getPropAt(i)] = v;
		}
		$.DropCallback.apply($.DropCallback, [o]);
	}
}
var __qtCallback__ = function(){
	var f = arguments[0][1];
	var a=[]; for (var i=1;i<arguments.length;i++) a.push(arguments[i]);
	if (typeof f=="function") f.apply(f, a);
}

// -- GENERAL

// setDropCallback object me, symbol callback, *callbackTarget
$.qtSetDropCallback = function(callback){
	$.DropCallback = callback;
	return this.gQt.setDropCallback(symbol("__qtDropCallback__")); // BUG: callbackTarget currently ignored???
}

/**
 * qtSetIdleSleep
 * Sets idle sleep time in ms: higher value=lower app CPU usage
 *
 * @param ms {Integer}
 */
$.qtSetIdleSleep = function (ms){
	this.gQt.setIdleSleep(ms);
}

// -- OBJECTS

//newObject object me, symbol objectClass, *parentWidgetID
$.qtNewObject = function(objectClass, parentWidgetID){
  arguments[0] = symbol(arguments[0]);
  return this.gQt.newObject.apply(this.gQt, arguments);
}

// setObjectCallback object me, integer objectID, symbol signal, symbol callback, *callbackTarget
$.qtSetObjectCallback = function(objectID, action, callback){
	return this.gQt.setObjectCallback(objectID, symbol(action), symbol("__qtCallback__"),list(callback));
}

//callObject object me, integer objectID, symbol action, *arguments
$.qtCallObject = function(objectID, action){	
	arguments[1] = symbol(arguments[1]);
	return this.gQt.callObject.apply(this.gQt, arguments);  
}

// -- WIDGETS/WINDOWS/DIALOGS

//createWidgetRegion object me, *rect, hwnd
$.qtCreateWidgetRegion = function(r){
  return this.gQt.createWidgetRegion.apply(this.gQt, arguments); 
}

//newWidget object me, any widgetClassOrUIFileOrData, *parentID, options
$.qtNewWidget = function(type, regionID){
	arguments[0] = symbol(arguments[0]);
  return this.gQt.newWidget.apply(this.gQt, arguments);
}
//newWidget object me, any widgetClassOrUIFileOrData, *parentID, options
$.qtNewWidgetUI = function(type, regionID){
  return this.gQt.newWidget.apply(this.gQt, arguments);
}
//newWindow object me, symbol widgetClass, *options
$.qtNewWindow = function(){
	arguments[0] = symbol(arguments[0]);
	if (arguments.length>3) arguments[3] = symbol(arguments[3]);
  return this.gQt.newWindow.apply(this.gQt, arguments); 
}
//newWindow object me, symbol widgetClass, *options
$.qtNewWindowUI = function(){
	if (arguments.length>3) arguments[3] = symbol(arguments[3]);
  return this.gQt.newWindow.apply(this.gQt, arguments); 
}

//newDialog object me, symbol widgetClass, *parentID, options
$.qtNewDialog = function(){
	if (arguments[0]=="MessageBox" &&arguments.length>3) arguments[4] = symbol(arguments[4]); ///?
	arguments[0] = symbol(arguments[0]);
  return this.gQt.newDialog.apply(this.gQt, arguments); 
}

// setWidgetCallback object me, integer widgetID, symbol signal, symbol callback, *callbackTarget
$.qtSetWidgetCallback = function(widgetID, action, callback){
	return this.gQt.setWidgetCallback(widgetID, symbol(action), symbol("__qtCallback__"),list(callback));
}

// setEventCallback object me, integer widgetID, integer eventType, symbol callback, *callbackTarget
$.qtSetEventCallback = function(widgetID, eventType, callback){
	return this.gQt.setEventCallback(widgetID, eventType, symbol("__qtCallback__"),list(callback));
}

//callWidget object me, integer widgetID, symbol action, *arguments
$.qtCallWidget = function(widgetID, action){
	arguments[1] = symbol(arguments[1]);
	return this.gQt.callWidget.apply(this.gQt, arguments);  
}

