/*
 * Simple Browser v0.6
 *
 * Demo application for Simple Framework.
 *
 * Copyleft 2012, Valentin Schmidt
 * Date: 2012-05-01
 */

this.scriptfile = "main.js"; // useful for debugging

var browser = {
	version:0.6,
	mainWindowID:0,
	webViewID:0,
	webPageID:0,
	addressBarID:0,
	statusBarID:0,
	printerID:0,
	trayIconID:0,
	state:0,
	childWindowIDs:[]
};

//--------------------------------------
// EVENT HANDLER CALLED BY RUNTIME
//--------------------------------------
function prepareMovie(){
	try{

	// JS DEBUGGING CONSOLE (uncomment to show console)
	//if ($.jsconsole) $.jsconsole.open();

	// SET DEFAULT ALERTHOOK (ONLY USED FOR UNCAUGHT EXCEPTIONS)
	$.setAlertHook();

	// MAKE PLAYHEAD LOOP ON CURRENT FRAME
	$.setFrameLoop();

	// INITIALIZE QT
	$.qtInit(20);

	// INITIALIZE BROWSER APP
	browser.init();

	}catch(e){eval($.CATCH);}
}

//--------------------------------------
// EVENT HANDLER CALLED BY RUNTIME
//--------------------------------------
function stopMovie(){
	try{

		// DESTROY
		$.qtCallObject(browser.webPageID, "destroy");
		$.qtCallWidget(browser.webViewID, "destroy");
		//$.qtCallWidget(browser.mainWindowID, "destroy");  // not really required (?)
		$.qtDestroy();

	}catch(e){eval($.CATCH);}
}

//--------------------------------------
// EVENT HANDLER CALLED BY RUNTIME
//--------------------------------------
function closeRequest(){
	// CLOSE CHILD WINDOWS
	for (var i in browser.childWindowIDs){
		$.qtCallWidget(browser.childWindowIDs[i], "close");
	}
	browser.writeSettings();
	_player.quit();
}

//--------------------------------------
// EVENT HANDLER CALLED BY RUNTIME
//--------------------------------------
function activateApplication(){
  $.qtSetIdleSleep(20); // idle sleep time in ms: higher value=lower app CPU usage
}

//--------------------------------------
// EVENT HANDLER CALLED BY RUNTIME
//--------------------------------------
function deactivateApplication(){
	$.qtSetIdleSleep(100); // idle sleep time in ms: higher value=lower app CPU usage
}

/**
 * browser.init
 * Initializes the browser app
 */
browser.init = function(){

  // LOAD COMPLEX WIDGET FROM UI FILE
  var fn = _movie.path + "assets" +$.PD+ "browser.ui";
  browser.mainWindowID = $.qtNewWindowUI(fn, 0);
  if (!browser.mainWindowID) return;
  $.qtCallWidget(browser.mainWindowID, "setGeometry", _movie.stage.rect);

  // QUIT APPLICATION WHEN MAIN WINDOW WAS CLOSED
  $.qtSetEventCallback(browser.mainWindowID, 19, closeRequest);

	// GET WEBVIEW
	browser.webViewID = $.qtCallWidget(browser.mainWindowID, "findChild", "webView");
	if (!browser.webViewID) return;
	
	// SET WEBVIEW SETTINGS (http://doc.qt.nokia.com/latest/qwebsettings.html#WebAttribute-enum)
  $.qtCallWidget(browser.webViewID, "SetGlobalSetting", 3, 1); // 3 = QWebSettings::PluginsEnabled  
  $.qtCallWidget(browser.webViewID, "SetGlobalSetting", 5, 1); // 3 = QWebSettings::JavascriptCanOpenWindows // ALLOW OPENING NEW WINDOWS (e.g. via target="_blank")
  
	// CREATE A CUSTOM WEBPAGE-OBJECT (REQUIRED FOR FEATURES LIKE NEW WINDOWS AND JS-COMMUNICATION)
	browser.webPageID = $.qtNewObject("WebPage", browser.mainWindowID);
	$.qtCallWidget(browser.webViewID, "setPage", browser.webPageID);
	$.qtCallObject(browser.webPageID, "setAllowNewWindows", 1);
	   
	// GET ADRESSBAR
  browser.addressBarID = $.qtCallWidget(browser.mainWindowID, "findChild", "addressBar");
  
  // GET STATUSBAR
  browser.statusBarID = $.qtCallWidget(browser.mainWindowID, "findChild", "statusbar");

  // CREATE A PRINTER-OBJECT
	browser.printerID = $.qtNewObject("Printer", browser.mainWindowID);
	
  // GO-BUTTON
  var goBtnID = $.qtCallWidget(browser.mainWindowID, "findChild", "goBtn");
  $.qtSetWidgetCallback(goBtnID, "clicked", browser.gotoUrl);
	
	$.qtSetWidgetCallback(browser.addressBarID, "returnPressed", browser.gotoUrl);
	
  // SET WEBVIEW-CALLBACKS
  $.qtSetWidgetCallback(browser.webViewID, "urlChanged", function(wID, tUrl){
  	$.qtCallWidget(browser.addressBarID, "setText", tUrl);
  });
  $.qtSetWidgetCallback(browser.webViewID, "loadProgress", function(wID, prog){
  	$.qtCallWidget(browser.statusBarID, "showMessage", "Loading: "+prog +"%");
  });

	// SET PAGE-CALLBACKS
  $.qtSetObjectCallback(browser.webPageID, "downloadRequested", function(objectID, tUrl){
  	$.log("downloadRequested", tUrl);
	});
  
  $.qtSetObjectCallback(browser.webPageID, "jsConsoleMessage", function(objectID, msgList){
		var msgArray = $.makeArray(msgList);
		for (var i in msgArray){
			$.log("BROWSER-CONSOLE>: "+msgArray[i]);
		}
	});

	$.qtSetObjectCallback(browser.webPageID, "windowCreated", function(objectID, newWebViewWinId){
  	var childWindowID = $.qtCallWidget(browser.mainWindowID, "find", newWebViewWinId);
  	browser.childWindowIDs.push(childWindowID);
	});
  
	browser.setMenuCallbacks();
	browser.createTrayIcon();
  browser.readSettings();
  
  // SET THE APPLICATION TITLE AND ICON
  $.qtCallWidget(browser.mainWindowID, "setWindowTitle", "Simple Browser");
  $.qtCallWidget(browser.mainWindowID, "setWindowIcon", _movie.path+"assets"+$.PD+"icon.png");

	// LOAD START URL
	$.qtCallWidget(browser.webViewID, "setUrl", "http://google.com/");
	
	// MINIMIZE TO TRAY BEHAVIOR
	$.qtSetEventCallback(browser.mainWindowID, 105, function(){// 105=WindowStateChange
		var state = $.qtCallWidget(browser.mainWindowID, "windowState");
		if (state==1||state==3){
			browser.state = state;
			$.qtCallWidget(browser.mainWindowID, "setVisible", 0);// to remove task menu entry!
			$.qtCallObject(browser.trayIconID, "show");
		}
	});

	// SHOW THE BROWSER
	$.qtCallWidget(browser.mainWindowID, "show");
}

/**
 * browser.gotoUrl
 * Sets menu callbacks (alternative to defining menu actions, as shown in Editor demo)
 */
browser.gotoUrl = function (widgetID){
  var tUrl = $.qtCallWidget(browser.addressBarID, "text");
  if (tUrl.substr(0,4)!="http"){
  	tUrl = "http://"+tUrl;
  	$.qtCallWidget(browser.addressBarID, "setText", tUrl);
	}
  $.qtCallWidget(browser.webViewID, "load", tUrl);
}

/**
 * browser.setMenuCallbacks
 * Sets menu callbacks (alternative to defining menu actions, as shown in Editor demo)
 */
browser.setMenuCallbacks = function(){
  // ADD MENU ACTIONS
  var menuID;

  menuID = $.qtCallWidget(browser.mainWindowID, "findChild", "menu_File");
  if (!menuID) return;

  $.qtSetWidgetCallback(menuID, "triggered", function(wID, tItemText){
  	switch(tItemText){
    case "&Open":
			var fn = $.qtNewDialog("FileOpenDialog", browser.mainWindowID, "Open File", "", "HTML files  (*.htm *.html);;Other Formats (*.*)");
			if (fn) $.qtCallWidget(browser.webViewID, "load", fn);
			break;
		case "Page Setup":
			if (browser.printerID){
				$.qtNewDialog("PageSetupDialog", browser.mainWindowID, browser.printerID);
		  }
	    break;
		case "&Print":
			if (browser.printerID){
				var ok = $.qtNewDialog("PrintDialog", browser.mainWindowID, browser.printerID);
		    if (ok) $.qtCallWidget(browser.webViewID, "print", browser.printerID);
		  }
	    break;
		case "Save as PDF":
			if (browser.printerID){
				var fn = $.qtNewDialog("FileSaveAsDialog", browser.mainWindowID, "Save as", "export", "PDF file (*.pdf);;PostScript file (*.ps)")
				if (fn){
					//$.qtCallObject(browser.printerID, "setOutputFormat", 1); // 0=NativeFormat, 1=PdfFormat, 2=PostScriptFormat
		      $.qtCallObject(browser.printerID, "setOutputFileName", fn);
		      var ok = $.qtCallWidget(browser.webViewID, "print", browser.printerID, 1, fn);
		      // reset
		      //$.qtCallObject(browser.printerID, "setOutputFormat", 0);
		      $.qtCallObject(browser.printerID, "setOutputFileName", "");
		    }
	    }
	    break;
    case "&Quit":
      closeRequest();
      break;
  	}
  });

	menuID = $.qtCallWidget(browser.mainWindowID, "findChild", "menu_Nav");
  if (!menuID) return;
  $.qtSetWidgetCallback(menuID, "triggered", function(wID, tItemText){ //cbMenuNavTriggered
	  switch(tItemText){
	  case "Forward":
			$.qtCallWidget(browser.webViewID, "forward");
			break;
	  case "Back":
	    $.qtCallWidget(browser.webViewID, "back");
			break;
	  case "Reload":
	  	$.qtCallWidget(browser.webViewID, "reload");
			break;
	  }
  });

	menuID = $.qtCallWidget(browser.mainWindowID, "findChild", "menu_Bookmarks");
  if (!menuID) return;
  $.qtSetWidgetCallback(menuID, "triggered", function(wID, tItemText){ //cbMenuBmTriggered
		var tUrl;
	  switch(tItemText){
	  case "Flash-Test":
			tUrl = "http://volvox.dasdeck.com/";
			break;
	  case "HTTPS-Test":
			tUrl = "https://secure.wikimedia.org/wikipedia/en/wiki/Main_Page";
			break;
	  case "HTML5-Test":
			tUrl = "http://valentin.dasdeck.com/processing/";
			break;
	  case "Shockwave10-Test":
			tUrl = "http://valentin.dasdeck.com/lingo/sw/info_sw10.php";
			break;
	  default: return;
	  }

	  $.qtCallWidget(browser.webViewID, "load", tUrl);
	  $.qtCallWidget(browser.addressBarID, "setText", tUrl);
  });

	menuID = $.qtCallWidget(browser.mainWindowID, "findChild", "menu_Help");
 	if (!menuID) return;
  $.qtSetWidgetCallback(menuID, "triggered", function(wID, tItemText){ //cbMenuHelpTriggered
	  switch(tItemText){
		case "Show JS Console":
			if ($.jsconsole) $.jsconsole.open();
			break;
		case "About":	
			$.qtNewDialog(
				"MessageBox",
				browser.mainWindowID, 
				"About",
				"<b>Simple Browser v"+browser.version+"</b><br><br>A demo application based on Simple Framework and QtWidgets Xtra.",
				"about"
			);
			break;
	  }
  });
}

/**
 * browser.createTrayIcon
 * Creates a tray icon and adds a tray menu.
 */
browser.createTrayIcon = function(){
  browser.trayIconID = $.qtNewObject("SystemTrayIcon");
  $.qtCallObject(browser.trayIconID, "setIcon", _movie.path + "assets"+$.PD+"icon.png");
  $.qtCallObject(browser.trayIconID, "setToolTip", "Simple Browser");

  // CREATE TRAY-CONTEXTMENU
  var menuID = $.qtNewWidget("Menu");

  var actionID = $.qtNewObject("Action", menuID);
  $.qtCallObject(actionID, "setText", "Restore");
  //$.qtCallObject(actionID, "setShortcut", "Ctrl+R");
  $.qtSetObjectCallback(actionID, "triggered", browser.restoreFromTray);
  $.qtCallWidget(menuID, "addAction", actionID);
  
  $.qtCallWidget(menuID, "addSeparator");

  actionID = $.qtNewObject("Action", menuID);
  $.qtCallObject(actionID, "setText", "&Quit");
  //$.qtCallObject(actionID, "setShortcut", "Ctrl+Q");
  $.qtSetObjectCallback(actionID, "triggered", closeRequest);
  $.qtCallWidget(menuID, "addAction", actionID);

  $.qtCallObject(browser.trayIconID, "setContextMenu", menuID);
  $.qtSetObjectCallback(browser.trayIconID, "activated", function(objectID, reason){
  	if (reason==3){//3=click, 2=doubleclick
  		browser.restoreFromTray();
  	}
  });
}

/**
 * browser.restoreFromTray
 * Restore application that was minimized to tray.
 */
browser.restoreFromTray = function(){
	if (browser.state==1){
		$.qtCallWidget(browser.mainWindowID, "setWindowState", 0);
		$.qtCallWidget(browser.mainWindowID, "setVisible", 1);
	}else if (browser.state==3){
		$.qtCallWidget(browser.mainWindowID, "setWindowState", 2);
		$.qtCallWidget(browser.mainWindowID, "setVisible", 1);
	}
	$.qtCallWidget(browser.mainWindowID, "activateWindow");
	$.qtCallObject(browser.trayIconID, "hide");
}

/**
 * browser.readSettings
 * Reads settings from registry.
 */
browser.readSettings = function(){
	var settingsID = $.qtNewObject("Settings", 0, "Valentin Schmidt", "Simple Browser");
	var res, p;
	res = $.qtCallObject(settingsID, "value", "size");
	if (res){
		if (res=="maximized"){
			$.qtCallWidget(browser.mainWindowID, "setWindowState", 2);
		}else{
			// RESTORE WINDOW SIZE
			p = res.split(",");
			$.qtCallWidget(browser.mainWindowID, "resize", p[0]*1, p[1]*1);
			// RESTORE WINDOW POSITION
			res = $.qtCallObject(settingsID, "value", "pos");
			if (res){
				p = res.split(",");
				$.qtCallWidget(browser.mainWindowID, "move", p[0]*1, p[1]*1);
			}
		}
	}
}

/**
 * browser.writeSettings
 * Writes settings to registry.
 */
browser.writeSettings = function(){
	var settingsID = $.qtNewObject("Settings", 0, "Valentin Schmidt", "Simple Browser");
	var s = $.qtCallWidget(browser.mainWindowID, "windowState");
	if (s==2){
		$.qtCallObject(settingsID, "setValue", "size", "maximized");
	}else{
		var p;
		// SAVE WINDOW POSITION
		p = $.qtCallWidget(browser.mainWindowID, "pos");
		$.qtCallObject(settingsID, "setValue", "pos", p.locH+","+p.locV);
		// SAVE WINDOW SIZE
		p = $.qtCallWidget(browser.mainWindowID, "size");	
		$.qtCallObject(settingsID, "setValue", "size", p.locH+","+p.locV);
	}
}

/**
 * browser.evaluateJavaScript
 * Evaluates given JS code with the (more powerful!) WebKit JS interpreter
 * You can use the alias
 *
 *   webkit("your code")
 *
 *   e.g. 
 *    webkit("Math.PI * 23")
 *    webkit("location.href")
 *    webkit("navigator.userAgent")
 *
 * in the JS-console to evaluate the specified code
 *
 * @param code {String}
 */
$.webkit = browser.evaluateJavaScript = function(code){
  if (!code || !browser.webViewID || !browser.webPageID) return;
  // GET MAIN FRAME
  var frameID = $.qtCallObject(browser.webPageID, "mainFrame");
	if (!frameID) return;
  var res = $.qtCallObject(frameID, "evaluateJavaScript", code);
  return res;
}
